(* ::Package:: *)

function output = ModelB22(x,x0,del,param)

% \[Mu]1[x1_,x2_] = k1+k2*x2; 
% \[Mu]2[x1_,x2_] = k3*(a-x2); 
% \[Sigma]11[x1_,x2_] = sqrt(x2)*sqrt(1-r^2); 
% \[Sigma]22[x1_,x2_] = sqrt(x2)*r; 
% \[Sigma]12[x1_,x2_] = 0;
% \[Sigma]21[x1_,x2_] = s*(x2^b); 
% Dv[x1_, x2_] = 1/2*(log(1-r^2)+2*log(s)+(1+2*b)log(x2));





x1 = x(1);
x2 = x(2);
x10 = x0(1);
x20 = x0(2);

k1 = param(1);
k2 = param(2);
k3 = param(3);
a = param(4);
r = param(5);
s = param(6);
b = param(7);

E = exp(1);

Dv = 1/2*(log(1-r^2)+2*log(s)+(1+2*b)log(x2)); 

cm1 = ((-6 + 9*r^2 + 2*b*(-1 + r^2))*(x1 - x10)^2*(x2 - x20)^2)/(48*(-1 + r^2)^2*x20^3) - ((x1 - x10)^2*(x2 - x20))/(4*(-1 + r^2)*x20^2) - (b*(x2 - x20)^3*x20^(-1 - 2*b))/ (2*(-1 + r^2)*s^2) - (r*(-2 + 3*r^2 + 8*b*(-1 + r^2) + 4*b^2*(-1 + r^2))*(x1 - x10)* (x2 - x20)^3*x20^(-(5/2) - b))/(24*(-1 + r^2)^2*s) + ((1 + 2*b)*r*(x1 - x10)*(x2 - x20)^2*x20^(-(3/2) - b))/(4*(-1 + r^2)*s) - (r*s*(x1 - x10)^3*(x2 - x20)*x20^(-(7/2) + b))/(24*(-1 + r^2)^2) + ((r^2 + 16*b*(-1 + r^2) + 28*b^2*(-1 + r^2))*(x2 - x20)^4)/ (x20^(2*(1 + b))*(96*(-1 + r^2)^2*s^2)) + (s^2*(x1 - x10)^4*x20^(-4 + 2*b))/ (96*(-1 + r^2)^2) + (x20^(-(3/2) - 2*b)*(x2^2*x20^(3/2) + x20^(7/2) + 2*r*s*(x1 - x10)*x20^(2 + b) + s^2*(x1 - x10)^2*x20^(1/2 + 2*b) - 2*x2*x20*(x20^(3/2) + r*s*(x1 - x10)*x20^b)))/(2*(-1 + r^2)*s^2);

c0 = -(((-3 + 2*b)*s^2*(x1 - x10)^2*x20^(-3 + 2*b))/(48*(-1 + r^2))) + ((x1 - x10)*x20^(-(3/2) - b)*(4*a*k3*r*x20 - 4*k3*r*x20^2 - s*x20^b*(4*k1*Sqrt[x20] + 4*k2*x20^(3/2) + (-1 + 2*b)*r*s*x20^b)))/(4*(-1 + r^2)*s) + ((x1 - x10)*(x2 - x20)*x20^(-(5/2) - b)*(-12*a*(1 + 2*b)*k3*r*x20 + 12*(-1 + 2*b)*k3*r*x20^2 - s*x20^b*(-24*k1*Sqrt[x20] + (15 - 28*b + 12*b^2)*r*s*x20^b)))/ (48*(-1 + r^2)*s) + ((x2 - x20)*x20^(-(3/2) - 2*b)*(-4*a*k3*x20^(3/2) + 4*k3*x20^(5/2) + s*x20^b*(4*k1*r*x20 + 4*k2*r*x20^2 + (-1 + 2*b)*s*x20^(1/2 + b))))/(4*(-1 + r^2)*s^2) + ((x2 - x20)^2*x20^(-(5/2) - 2*b)*(48*a*b*k3*x20^(3/2) + 24*(1 - 2*b)*k3*x20^(5/2) - s*x20^b*(12*(1 + 2*b)*k1*r*x20 + 12*(-1 + 2*b)*k2*r*x20^2 + (-9 + 14*b)*s*x20^(1/2 + b))))/ (48*(-1 + r^2)*s^2);

c1 = (1/(96*(-1 + r^2)*s^2))*(x20^(-(5/2) - 2*b)*(48*a^2*k3^2*x20^(5/2) + 48*k3^2*x20^(9/2) - 24*k3*s*x20^(2 + b)*(-4*k1*r*x20 - 4*k2*r*x20^2 + (-1 + 2*b)*(-2 + r^2)*s*x20^(1/2 + b)) + s^2*x20^(2*b)*(48*k1^2*x20^(3/2) + 48*k2^2*x20^(7/2) + 24*(-1 + 2*b)*k2*r*s*x20^(2 + b) + (-3 + 6*r^2 + b*(28 - 40*r^2) + 12*b^2*(-1 + 2*r^2))*s^2*x20^(1/2 + 2*b) + 24*k1*x20*(4*k2*x20^(3/2) + (-1 + 2*b)*r*s*x20^b)) - 24*a*k3*x20*(4*k3*x20^(5/2) - s*x20^b*(-4*k1*r*x20 - 4*k2*r*x20^2 + (r^2 + 2*b*(-2 + r^2))*s*x20^(1/2 + b)))));

output = - log(2*pi*del) - Dv + cm1/del + c0 + c1*del ;
